<template>
	<el-dialog v-model="visible" :title="!dataForm.id ? '新增' : '修改'" :close-on-click-modal="false">
		<el-form ref="dataFormRef" :model="dataForm" :rules="dataRules" label-width="100px" @keyup.enter="submitHandle()">
			<el-form-item label="订单编号" prop="purchaseId">
				<el-input v-model="dataForm.purchaseId" placeholder=""></el-input>
			</el-form-item>
			<el-form-item label="书籍编号" prop="bookId">
				<el-input v-model="dataForm.bookId" placeholder=""></el-input>
			</el-form-item>
			<el-form-item label="书本价格" prop="price">
				<el-input v-model="dataForm.price" placeholder=""></el-input>
			</el-form-item>
		</el-form>
		<template #footer>
			<el-button @click="visible = false">取消</el-button>
			<el-button type="primary" @click="submitHandle()">确定</el-button>
		</template>
	</el-dialog>
</template>

<script setup lang="ts">
import { reactive, ref } from 'vue'
import { ElMessage } from 'element-plus/es'
import { useT_purchase_detailsApi, useT_purchase_detailsSubmitApi } from '@/api/maku/t_purchase_details'

const emit = defineEmits(['refreshDataList'])

const visible = ref(false)
const dataFormRef = ref()

const dataForm = reactive({
	id: '',
	purchaseId: '',
	bookId: '',
	price: '',
})

const init = (id?: number) => {
	visible.value = true
	dataForm.id = ''

	// 重置表单数据
	if (dataFormRef.value) {
		dataFormRef.value.resetFields()
	}

	if (id) {
		getT_purchase_details(id)
	}
}

const getT_purchase_details = (id: number) => {
	useT_purchase_detailsApi(id).then(res => {
		Object.assign(dataForm, res.data)
	})
}

const dataRules = ref({
	purchaseId: [{ required: true, message: '必填项不能为空', trigger: 'blur' }],
	price: [{ required: true, message: '必填项不能为空', trigger: 'blur' }],
	bookId: [{ required: true, message: '必填项不能为空', trigger: 'blur' }],
})

// 表单提交
const submitHandle = () => {
	dataFormRef.value.validate((valid: boolean) => {
		if (!valid) {
			return false
		}

		useT_purchase_detailsSubmitApi(dataForm).then(() => {
			ElMessage.success({
				message: '操作成功',
				duration: 500,
				onClose: () => {
					visible.value = false
					emit('refreshDataList')
				}
			})
		})
	})
}

defineExpose({
	init
})
</script>
